{-
 - Copyright (C) 2015-2016 Ramakrishnan Muthukrishnan <ram@rkrishnan.org>
 -
 - This file is part of FuncTorrent.
 -
 - FuncTorrent is free software; you can redistribute it and/or modify
 - it under the terms of the GNU General Public License as published by
 - the Free Software Foundation; either version 3 of the License, or
 - (at your option) any later version.
 -
 - FuncTorrent is distributed in the hope that it will be useful,
 - but WITHOUT ANY WARRANTY; without even the implied warranty of
 - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 - GNU General Public License for more details.
 -
 - You should have received a copy of the GNU General Public License
 - along with FuncTorrent; if not,  see <http://www.gnu.org/licenses/>
 -}

module BencodeTests (tests) where

import FuncTorrent.Bencode (encode, decode, BVal(..))

import Test.Hspec
import Test.QuickCheck
import Data.ByteString.Char8 (unpack, pack)

propEncodeDecode :: BVal -> Bool
propEncodeDecode bval = let encoded = encode bval
                            decoded = decode encoded
                        in Right bval == decoded

tests :: IO ()
tests = hspec $ do
  describe "BVal tests" $ do
    it "encode/decode" $ do
      property $ \bval ->
        let encoded = encode bval
            decoded = decode encoded
        in Right bval == decoded
